// ClassOptions3.cpp : implementation file
//

#include "stdafx.h"
#include "VisualClassBuilder.h"
#include "ClassOptions3.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClassOptions3 property page

IMPLEMENT_DYNCREATE(CClassOptions3, CPropertyPage)

CClassOptions3::CClassOptions3() : CPropertyPage(CClassOptions3::IDD)
{
	//{{AFX_DATA_INIT(CClassOptions3)
	m_Static = FALSE;
	m_Virtual = FALSE;
	m_Comment = _T("");
	m_Name = _T("");
	m_Type = _T("");
	m_Access = 0;
	//}}AFX_DATA_INIT

	// Init members
	m_pMethodList = NULL;
	m_iMethodNumber = 0;
}

CClassOptions3::~CClassOptions3()
{
}

void CClassOptions3::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClassOptions3)
	DDX_Control(pDX, IDC_LIST_METHODS, m_MethodsList);
	DDX_Check(pDX, IDC_CHECK_STATIC, m_Static);
	DDX_Check(pDX, IDC_CHECK_VIRTUAL, m_Virtual);
	DDX_Text(pDX, IDC_EDIT_COMMENT, m_Comment);
	DDV_MaxChars(pDX, m_Comment, 256);
	DDX_Text(pDX, IDC_EDIT_NAME, m_Name);
	DDV_MaxChars(pDX, m_Name, 256);
	DDX_Text(pDX, IDC_EDIT_TYPE, m_Type);
	DDV_MaxChars(pDX, m_Type, 256);
	DDX_Radio(pDX, IDC_RADIO_ACCESS, m_Access);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CClassOptions3, CPropertyPage)
	//{{AFX_MSG_MAP(CClassOptions3)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_UPDATE, OnButtonUpdate)
	ON_NOTIFY(NM_CLICK, IDC_LIST_METHODS, OnClickListMethods)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClassOptions3 message handlers

void CClassOptions3::OnButtonAdd() 
{
	UpdateData(TRUE);

	// Check for valid method
	if ((m_Type != _T("")) && (m_Name != _T("")))
	{
		// Add new method
		int item = m_MethodsList.InsertItem(m_MethodsList.GetItemCount(), m_Type);
		m_MethodsList.SetItemText(item, 1, m_Name);
		m_MethodsList.SetItemText(item, 2, m_Comment);
		CString strAccessLevel;
		switch (m_Access)
		{
			case 0:
			{
				strAccessLevel = _T("public");
			}
			break;

			case 1:
			{
				strAccessLevel = _T("protected");
			}
			break;

			case 2:
			{
				strAccessLevel = _T("private");
			}
			break;
		}
		m_MethodsList.SetItemText(item, 3, strAccessLevel);
		if (m_Virtual)
			m_MethodsList.SetItemText(item, 4, _T("yes"));
		else
			m_MethodsList.SetItemText(item, 4, _T("no"));
		if (m_Static)
			m_MethodsList.SetItemText(item, 5, _T("yes"));
		else
			m_MethodsList.SetItemText(item, 5, _T("no"));

		// Update method list
		UpdateMethods();
	}
	else
		AfxMessageBox(_T("Some field values are not valid..."), MB_OK);
}

void CClassOptions3::OnButtonRemove() 
{
	// Check for selected method
	POSITION pos = m_MethodsList.GetFirstSelectedItemPosition();
	int item = m_MethodsList.GetNextSelectedItem(pos);
	if (item != -1)
	{
		// Remove method
		m_MethodsList.DeleteItem(item);

		// Update method list
		UpdateMethods();
	}	
}

void CClassOptions3::OnButtonUpdate() 
{
	UpdateData(TRUE);

	// Check for selected method
	POSITION pos = m_MethodsList.GetFirstSelectedItemPosition();
	int item = m_MethodsList.GetNextSelectedItem(pos);
	if (item != -1)
	{
		// Check for valid method
		if ((m_Type != _T("")) && (m_Name != _T("")))
		{
			// Update method
			m_MethodsList.SetItemText(item, 0, m_Type);
			m_MethodsList.SetItemText(item, 1, m_Name);
			m_MethodsList.SetItemText(item, 2, m_Comment);
			CString strAccessLevel;
			switch (m_Access)
			{
				case 0:
				{
					strAccessLevel = _T("public");
				}
				break;

				case 1:
				{
					strAccessLevel = _T("protected");
				}
				break;

				case 2:
				{
					strAccessLevel = _T("private");
				}
				break;
			}
			m_MethodsList.SetItemText(item, 3, strAccessLevel);
			if (m_Virtual)
				m_MethodsList.SetItemText(item, 4, _T("yes"));
			else
				m_MethodsList.SetItemText(item, 4, _T("no"));
			if (m_Static)
				m_MethodsList.SetItemText(item, 5, _T("yes"));
			else
				m_MethodsList.SetItemText(item, 5, _T("no"));

			// Update method list
			UpdateMethods();
		}
		else
			AfxMessageBox(_T("Some field values are not valid..."), MB_OK);
	}	
}

BOOL CClassOptions3::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// Create variables list control
	m_MethodsList.InsertColumn(0, _T("Type"), LVCFMT_LEFT, 85);
	m_MethodsList.InsertColumn(1, _T("Name"), LVCFMT_LEFT, 110);
	m_MethodsList.InsertColumn(2, _T("Comment"), LVCFMT_LEFT, 60);
	m_MethodsList.InsertColumn(3, _T("Access"), LVCFMT_CENTER, 60);
	m_MethodsList.InsertColumn(4, _T("Virtual"), LVCFMT_CENTER, 60);
	m_MethodsList.InsertColumn(5, _T("Static"), LVCFMT_CENTER, 60);
	m_MethodsList.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

	// Update method list
	int item;
	for (int i=0; i<m_iMethodNumber; i++)
	{
		item = m_MethodsList.InsertItem(m_MethodsList.GetItemCount(), m_pMethodList[i].lpszMethodType);
		m_MethodsList.SetItemText(item, 1, m_pMethodList[i].lpszMethodName);
		m_MethodsList.SetItemText(item, 2, m_pMethodList[i].lpszMethodComment);
		switch (m_pMethodList[i].methodAccessLevel)
		{
			case AL_PUBLIC:
			{
				m_MethodsList.SetItemText(item, 3, _T("public"));
			}
			break;
			case AL_PROTECTED:
			{
				m_MethodsList.SetItemText(item, 3, _T("protected"));
			}
			break;
			case AL_PRIVATE:
			{
				m_MethodsList.SetItemText(item, 3, _T("private"));
			}
			break;
		}
		if (m_pMethodList[i].bVirtual)
			m_MethodsList.SetItemText(item, 4, _T("yes"));
		else
			m_MethodsList.SetItemText(item, 4, _T("no"));
		if (m_pMethodList[i].bStatic)
			m_MethodsList.SetItemText(item, 5, _T("yes"));
		else
			m_MethodsList.SetItemText(item, 5, _T("no"));
	}

	// Init members
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CClassOptions3::UpdateMethods()
{
	// Resize method list
	m_iMethodNumber = m_MethodsList.GetItemCount();
	m_pMethodList = (METHOD_TYPE*)realloc(m_pMethodList, m_iMethodNumber*sizeof(METHOD_TYPE));

	// Update method list
	CString strAccessLevel, strVirtual, strStatic;
	for (int i=0; i<m_MethodsList.GetItemCount(); i++)
	{
		// Update method
		_tcscpy(m_pMethodList[i].lpszMethodType, m_MethodsList.GetItemText(i, 0));
		_tcscpy(m_pMethodList[i].lpszMethodName, m_MethodsList.GetItemText(i, 1));
		_tcscpy(m_pMethodList[i].lpszMethodComment, m_MethodsList.GetItemText(i, 2));
		strAccessLevel = m_MethodsList.GetItemText(i, 3);
		if (strAccessLevel == _T("public"))
		{
			m_pMethodList[i].methodAccessLevel = AL_PUBLIC;
		}
		else if (strAccessLevel == _T("protected"))
		{
			m_pMethodList[i].methodAccessLevel = AL_PROTECTED;
		}
		else
		{
			m_pMethodList[i].methodAccessLevel = AL_PRIVATE;
		}
		strVirtual = m_MethodsList.GetItemText(i, 4);
		if (strVirtual == _T("yes"))
			m_pMethodList[i].bVirtual = TRUE;
		else
			m_pMethodList[i].bVirtual = FALSE;
		strStatic = m_MethodsList.GetItemText(i, 5);
		if (strStatic == _T("yes"))
			m_pMethodList[i].bStatic = TRUE;
		else
			m_pMethodList[i].bStatic = FALSE;
	}
}

void CClassOptions3::OnClickListMethods(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Check for selected method
	POSITION pos = m_MethodsList.GetFirstSelectedItemPosition();
	int item = m_MethodsList.GetNextSelectedItem(pos);
	if (item != -1)
	{
		// Get method
		m_Type = m_MethodsList.GetItemText(item, 0);
		m_Name = m_MethodsList.GetItemText(item, 1);
		m_Comment = m_MethodsList.GetItemText(item, 2);
		CString strAccessLevel = m_MethodsList.GetItemText(item, 3);
		if (strAccessLevel == _T("public"))
		{
			m_Access = 0;
		}
		else if (strAccessLevel == _T("protected"))
		{
			m_Access = 1;
		}
		else
		{
			m_Access = 2;
		}
		CString strVirtual= m_MethodsList.GetItemText(item, 4);
		if (strVirtual == _T("yes"))
			m_Virtual = TRUE;
		else
			m_Virtual = FALSE;
		CString strStatic = m_MethodsList.GetItemText(item, 5);
		if (strStatic == _T("yes"))
			m_Static = TRUE;
		else
			m_Static = FALSE;
	}

	UpdateData(FALSE);

	*pResult = 0;
}
