// ClassOptions4.cpp : implementation file
//

#include "stdafx.h"
#include "VisualClassBuilder.h"
#include "ClassOptions4.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClassOptions4 property page

IMPLEMENT_DYNCREATE(CClassOptions4, CPropertyPage)

CClassOptions4::CClassOptions4() : CPropertyPage(CClassOptions4::IDD)
{
	//{{AFX_DATA_INIT(CClassOptions4)
	m_bComments = TRUE;
	m_bDocumentation = TRUE;
	m_bMFCHeaders = FALSE;
	//}}AFX_DATA_INIT

	// Init members
	m_pParentList = NULL;
	m_iParentNumber = 0;
	m_pClassList = NULL;
	m_iClassNumber = 0;
}

CClassOptions4::~CClassOptions4()
{
}

void CClassOptions4::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClassOptions4)
	DDX_Control(pDX, IDC_LIST_PARENTS_LIST, m_ParentsList);
	DDX_Control(pDX, IDC_COMBO_TYPE, m_Type);
	DDX_Control(pDX, IDC_COMBO_PARENTS, m_Parents);
	DDX_Check(pDX, IDC_CHECK_COMMENTS, m_bComments);
	DDX_Check(pDX, IDC_CHECK_DOCUMENTATION, m_bDocumentation);
	DDX_Check(pDX, IDC_CHECK_MFC_HEADERS, m_bMFCHeaders);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CClassOptions4, CPropertyPage)
	//{{AFX_MSG_MAP(CClassOptions4)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClassOptions4 message handlers

BOOL CClassOptions4::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// Init members
	m_Parents.SetCurSel(0);
	m_Type.SetCurSel(0);

	// Create parents list control
	m_ParentsList.InsertColumn(0, _T("Parent class"), LVCFMT_LEFT, 90);
	m_ParentsList.InsertColumn(1, _T("Method"), LVCFMT_CENTER, 65);
	m_ParentsList.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

	// Update parent list
	int item;
	for (int i=0; i<m_iParentNumber; i++)
	{
		item = m_ParentsList.InsertItem(m_ParentsList.GetItemCount(), m_pParentList[i].lpszClassName);
		switch (m_pParentList[i].classAccessLevel)
		{
			case AL_PUBLIC:
			{
				m_ParentsList.SetItemText(item, 1, _T("public"));
			}
			break;
			case AL_PROTECTED:
			{
				m_ParentsList.SetItemText(item, 1, _T("protected"));
			}
			break;
			case AL_PRIVATE:
			{
				m_ParentsList.SetItemText(item, 1, _T("private"));
			}
			break;
		}
	}

	// Update class list
	for (int j=0; j<m_iClassNumber; j++)
	{
		// Add class
		m_Parents.InsertString(m_Parents.GetCount(), m_pClassList[j].lpszClassName);
	}
	m_Parents.SetCurSel(0);

	// Init members
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CClassOptions4::OnButtonAdd() 
{
	// Check for existing parents
	if (m_Parents.GetCount() > 0)
	{
		// Get class name
		CString strClassName;
		m_Parents.GetLBText(m_Parents.GetCurSel(), strClassName);

		// Get access level
		CString strAccessLevel;
		m_Type.GetLBText(m_Type.GetCurSel(), strAccessLevel);

		// Check for existing parent
		bool found = false;
		for (int i=0; i<m_ParentsList.GetItemCount(); i++)
		{
			if (m_ParentsList.GetItemText(i, 0) == strClassName)
			{
				found = true;
				break;
			}
		}

		// If parent class does not exist
		if (!found)
		{
			// Add new parent class
			int item = m_ParentsList.InsertItem(m_ParentsList.GetItemCount(), strClassName);
			m_ParentsList.SetItemText(item, 1, strAccessLevel);

			// Update parent list
			UpdateParents();
		}
		else
			AfxMessageBox(_T("Parent class already added to the list !"), MB_OK);
	}
}

void CClassOptions4::OnButtonRemove() 
{
	// Check for selected parent
	POSITION pos = m_ParentsList.GetFirstSelectedItemPosition();
	int item = m_ParentsList.GetNextSelectedItem(pos);
	if (item != -1)
	{
		// Remove parent
		m_ParentsList.DeleteItem(item);

		// Update parent list
		UpdateParents();
	}	
}

void CClassOptions4::UpdateParents()
{
	// Resize parent list
	m_iParentNumber = m_ParentsList.GetItemCount();
	m_pParentList = (PARENT_NODE*)realloc(m_pParentList, m_iParentNumber*sizeof(PARENT_NODE));

	// Update parent list
	CString strAccessLevel;
	for (int i=0; i<m_ParentsList.GetItemCount(); i++)
	{
		// Update parent
		_tcscpy(m_pParentList[i].lpszClassName, m_ParentsList.GetItemText(i, 0));
		strAccessLevel = m_ParentsList.GetItemText(i, 1);
		if (strAccessLevel == _T("public"))
		{
			m_pParentList[i].classAccessLevel = AL_PUBLIC;
		}
		else if (strAccessLevel == _T("protected"))
		{
			m_pParentList[i].classAccessLevel = AL_PROTECTED;
		}
		else
		{
			m_pParentList[i].classAccessLevel = AL_PRIVATE;
		}

		for (int j=0; j<m_iClassNumber; j++)
		{
			if (_tcscmp(m_pClassList[j].lpszClassName, m_pParentList[i].lpszClassName) == 0)
			{
				_tcscpy(m_pParentList[i].lpszClassHeaderFile, m_pClassList[j].lpszClassHeaderFile);
			}
		}
	}
}
