// StructOptions2.cpp : implementation file
//

#include "stdafx.h"
#include "VisualClassBuilder.h"
#include "StructOptions2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStructOptions2 property page

IMPLEMENT_DYNCREATE(CStructOptions2, CPropertyPage)

CStructOptions2::CStructOptions2() : CPropertyPage(CStructOptions2::IDD)
{
	//{{AFX_DATA_INIT(CStructOptions2)
	m_Comment = _T("");
	m_Name = _T("");
	m_Type = _T("");
	//}}AFX_DATA_INIT
}

CStructOptions2::~CStructOptions2()
{
}

void CStructOptions2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStructOptions2)
	DDX_Control(pDX, IDC_LIST_VARIABLES, m_VariablesList);
	DDX_Text(pDX, IDC_EDIT_COMMENT, m_Comment);
	DDV_MaxChars(pDX, m_Comment, 256);
	DDX_Text(pDX, IDC_EDIT_NAME, m_Name);
	DDV_MaxChars(pDX, m_Name, 256);
	DDX_Text(pDX, IDC_EDIT_TYPE, m_Type);
	DDV_MaxChars(pDX, m_Type, 256);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStructOptions2, CPropertyPage)
	//{{AFX_MSG_MAP(CStructOptions2)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_UPDATE, OnButtonUpdate)
	ON_NOTIFY(NM_CLICK, IDC_LIST_VARIABLES, OnClickListVariables)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStructOptions2 message handlers

void CStructOptions2::OnButtonAdd() 
{
	UpdateData(TRUE);

	// Check for valid variable
	if ((m_Type != _T("")) && (m_Name != _T("")))
	{
		// Add new variable
		int item = m_VariablesList.InsertItem(m_VariablesList.GetItemCount(), m_Type);
		m_VariablesList.SetItemText(item, 1, m_Name);
		m_VariablesList.SetItemText(item, 2, m_Comment);

		// Update variable list
		UpdateVariables();
	}
	else
		AfxMessageBox(_T("Some field values are not valid..."), MB_OK);}

void CStructOptions2::OnButtonRemove() 
{
	// Check for selected variable
	POSITION pos = m_VariablesList.GetFirstSelectedItemPosition();
	int item = m_VariablesList.GetNextSelectedItem(pos);
	if (item != -1)
	{
		// Remove variable
		m_VariablesList.DeleteItem(item);

		// Update variable list
		UpdateVariables();
	}	
}

void CStructOptions2::OnButtonUpdate() 
{
	UpdateData(TRUE);

	// Check for selected variable
	POSITION pos = m_VariablesList.GetFirstSelectedItemPosition();
	int item = m_VariablesList.GetNextSelectedItem(pos);
	if (item != -1)
	{
		// Check for valid variable
		if ((m_Type != _T("")) && (m_Name != _T("")))
		{
			// Update variable
			m_VariablesList.SetItemText(item, 0, m_Type);
			m_VariablesList.SetItemText(item, 1, m_Name);
			m_VariablesList.SetItemText(item, 2, m_Comment);

			// Update variable list
			UpdateVariables();
		}
		else
			AfxMessageBox(_T("Some field values are not valid..."), MB_OK);
	}
}

void CStructOptions2::OnClickListVariables(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Check for selected variable
	POSITION pos = m_VariablesList.GetFirstSelectedItemPosition();
	int item = m_VariablesList.GetNextSelectedItem(pos);
	if (item != -1)
	{
		// Get variable
		m_Type = m_VariablesList.GetItemText(item, 0);
		m_Name = m_VariablesList.GetItemText(item, 1);
		m_Comment = m_VariablesList.GetItemText(item, 2);
	}

	UpdateData(FALSE);
	
	*pResult = 0;
}

BOOL CStructOptions2::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// Create variables list control
	m_VariablesList.InsertColumn(0, _T("Type"), LVCFMT_LEFT, 90);
	m_VariablesList.InsertColumn(1, _T("Name"), LVCFMT_LEFT, 120);
	m_VariablesList.InsertColumn(2, _T("Comment"), LVCFMT_LEFT, 80);
	m_VariablesList.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

	// Update variable list
	int item;
	for (int i=0; i<m_iVariableNumber; i++)
	{
		item = m_VariablesList.InsertItem(m_VariablesList.GetItemCount(), m_pVariableList[i].lpszVariableType);
		m_VariablesList.SetItemText(item, 1, m_pVariableList[i].lpszVariableName);
		m_VariablesList.SetItemText(item, 2, m_pVariableList[i].lpszVariableComment);
	}

	// Init members
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CStructOptions2::UpdateVariables()
{
	// Resize variable list
	m_iVariableNumber = m_VariablesList.GetItemCount();
	m_pVariableList = (VARIABLE_TYPE*)realloc(m_pVariableList, m_iVariableNumber*sizeof(VARIABLE_TYPE));

	// Update variable list
	for (int i=0; i<m_VariablesList.GetItemCount(); i++)
	{
		// Update variable
		_tcscpy(m_pVariableList[i].lpszVariableType, m_VariablesList.GetItemText(i, 0));
		_tcscpy(m_pVariableList[i].lpszVariableName, m_VariablesList.GetItemText(i, 1));
		_tcscpy(m_pVariableList[i].lpszVariableComment, m_VariablesList.GetItemText(i, 2));
	}
}
