// VCBObject.cpp: implementation of the CVCBObject class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VCBObject.h"



CVCBObject::CVCBObject()
{
	// Init members
	m_bIsSelected = FALSE;
	m_bShowShadow = TRUE;

	// Init memory DC and bitmap
	m_hMemDC = NULL;
	m_hMemBitmap = NULL;
	m_hOldMemBitmap = NULL;

	// Init shadow DC and bitmap
	m_hShadowDC = NULL;
	m_hShadowBitmap = NULL;
	m_hOldShadowBitmap = NULL;

	// Init background DC and bitmap
	m_hBackgroundDC = NULL;
	m_hBackgroundBitmap = NULL;
	m_hOldBackgroundBitmap = NULL;
}

CVCBObject::~CVCBObject()
{
	// Delete memory DC and bitmap
	if (m_hMemDC)
	{
		SelectObject(m_hMemDC, m_hOldMemBitmap);
		DeleteDC(m_hMemDC);
		DeleteObject(m_hMemBitmap);
		m_hMemDC = NULL;
		m_hMemBitmap = NULL;
		m_hOldMemBitmap = NULL;
	}

	// Delete shadow DC and bitmap
	if (m_hShadowDC)
	{
		SelectObject(m_hShadowDC, m_hOldShadowBitmap);
		DeleteDC(m_hShadowDC);
		DeleteObject(m_hShadowBitmap);
		m_hShadowDC = NULL;
		m_hShadowBitmap = NULL;
		m_hOldShadowBitmap = NULL;
	}

	// Delete background DC and bitmap
	if (m_hBackgroundDC)
	{
		SelectObject(m_hBackgroundDC, m_hOldBackgroundBitmap);
		DeleteDC(m_hBackgroundDC);
		DeleteObject(m_hBackgroundBitmap);
		m_hBackgroundDC = NULL;
		m_hBackgroundBitmap = NULL;
		m_hOldBackgroundBitmap = NULL;
	}
}

VCBOBJ_TYPE CVCBObject::GetVCBObjectType()
{
	// Get object type
	return m_nObjectType;
}

BOOL CVCBObject::IsVCBObjectSelected()
{
	// Get object selection flag
	return m_bIsSelected;
}

void CVCBObject::ShowVCBObjectShadow(BOOL bShadow)
{
	// Set object shadow flag
	m_bShowShadow = bShadow;
}

DWORD CVCBObject::GetVCBObjectID()
{
	// Get object ID
	return m_dwObjectID;
}

void CVCBObject::SetVCBObjectID(DWORD id)
{
	// Set object ID
	m_dwObjectID = id;
}
